#ifdef COPYRIGHT_INFORMATION
#include "gplv3.h"
#endif
/*
 *
 *  Copyright (c) 2004-2011 Edscott Wilson Garcia <edscott@users.sf.net>
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library;  */

#include <sys/types.h>
#include <sys/wait.h>

#include "rfm.h"

#if 0
// This is not working in 3.14.0 (with no icontheme installed)
// maybe it will work on later version.
//
// rodent-apps must work even if no icontheme is defined.
//
//#if GTK_MAJOR_VERSION==3 && GTK_MINOR_VERSION>=14
static void
define_builtin_icons(void){
    // FIXME: 
    // gtk 3.14 method... 
    // add emblems and stock

    //gchar *resource_path = g_build_filename();
    const gchar *resource_path = "/home/test/share/icons/rfm/scalable/stock/";

    // This adds preset directories into resource /org/gtk/libgtk/icons
    // (16x16/, 22x22/, 24x24/, 32x32/)
    gtk_icon_theme_add_resource_path (gtk_icon_theme_get_default (),resource_path);

  gchar **icon_files;
  gchar **icon_file;
  GError *error = NULL;

  //icon_files = g_resources_enumerate_children (resource_path,
  icon_files = g_resources_enumerate_children ("/org/gtk/libgtk/icons",
                                               G_RESOURCE_LOOKUP_FLAGS_NONE,
                                               &error);

  for (icon_file = icon_files; icon_file != NULL && *icon_file != NULL; icon_file++)
    {
      gchar *icon_path;
      GdkPixbuf *pixbuf;

      fprintf (stderr, "iconfile: \"%s%s\" \n", resource_path, *icon_file);
    }
}


#else
static gchar *icon_ids[]={
// actions
    "xffm/stock_add/compositeX/emblem_greenball","list-add-symbolic",
    "xffm/stock_remove/compositeX/emblem_redball","list-remove-symbolic",
    "xffm/emblem_edit","edit-symbolic",
    "xffm/emblem_find","edit-find-symbolic",

    "xffm/stock_dialog-warning","dialog-warning-symbolic",
    "xffm/stock_process-reset","process-stop-symbolic",
    "xffm/stock_document-open","document-open-recent",   
    "xffm/stock_file","text-x-generic",
    "xffm/stock_document-open","document-open",
    "xffm/emblem_keyhole","dialog-password",
    "xffm/emblem_keyhole","dialog-password-symbolic",
    "xffm/stock_go-bottom","window-minimize-symbolic",
    "xffm/stock_window-close","window-close-symbolic",

    "xffm/stock_go-down","pan-down-symbolic",
    "xffm/stock_go-up","pan-up-symbolic",

// places
//
    "xffm/emblem_documents","folder-documents-symbolic",
    "xffm/stock_directory/compositeX/stock_go-down","folder-download-symbolic",
    "xffm/emblem_music","folder-music-symbolic",
    "xffm/emblem_image","folder-pictures-symbolic",
    "xffm/stock_directory/compositeX/","folder-publicshare-symbolic",
    "xffm/emblem_shared","folder-remote-symbolic",
    "xffm/stock_directory/compositeX/stock_edit-find","folder-saved-search-symbolic",
    "xffm/stock_directory","folder-symbolic",
    "xffm/stock_directory/compositeX/stock_format-text-bold",
         "folder-templates-symbolic",
    "xffm/emblem_video","folder-videos-symbolic",
    "xffm/stock_directory/compositeX/emblem_network","network-server-symbolic",
    "xffm/emblem_network","network-workgroup-symbolic",
    "xffm/emblem_start-here","start-here-symbolic",
    "xffm/emblem_bookmark","user-bookmarks-symbolic",
    "xffm/emblem_desktop","user-desktop-symbolic",
    "xffm/stock_home","user-home-symbolic",
    "xffm/emblem_bak","user-trash-symbolic",
// devices
    "xffm/stock_harddisk","drive-harddisk-symbolic",
    "xffm/stock_harddisk","harddisk-symbolic",
    "xffm/emblem_broken","image-missing",

        NULL,NULL
    
};

static void
define_builtin_icons(void){
    // gtk 3.10 eliminates stock built in icons. So we must add those we 
    // shall need if no icontheme is in current use. Yeah, rodent apps
    // should be able to work when *no* icon theme is present.

    gint sizes[]={16,22, 24, 32, 48, 0};
  /*  gchar *icon_ids[]={
        "xffm/stock_add/compositeX/emblem_greenball", "list-add-symbolic", 
        "xffm/stock_remove/compositeX/emblem_redball", "list-remove-symbolic", 
//        "xffm/stock_add", "list-add-symbolic", 
//        "xffm/stock_remove", "list-remove-symbolic",
        "xffm/stock_home", "user-home-symbolic",
//        "xffm/emblem_folder/compositeX/emblem_home", "user-home-symbolic",
        "xffm/emblem_desktop", "user-desktop-symbolic",
        "xffm/stock_directory", "folder-symbolic",
        "xffm/stock_file", "file",//?
        "xffm/emblem_symbolic-link", "file-symbolic",//?
        "xffm/emblem_symbolic-link", "missing-image",//?

"xffm/stock_harddisk", "drive-harddisk-symbolic",
"xffm/stock_jump", "media-eject-symbolic",//
"xffm/emblem_documents", "folder-documents-symbolic",
"xffm/emblem_downloads", "folder-download-symbolic",
"xffm/emblem_music", "folder-music-symbolic",
"xffm/emblem_photos", "folder-pictures-symbolic",
"xffm/emblem_shared", "folder-publicshare-symbolic",
"xffm/stock_file", "folder-templates-symbolic",//
"xffm/emblem_video", "folder-videos-symbolic",
"xffm/stock_find", "folder-saved-search-symbolic",
        NULL,NULL
    };*/
    gint i; gchar **g=icon_ids;
    for (i=0; sizes[i] > 0; i++) for (; g && *g; g=g+2)
    {

        GdkPixbuf *pixbuf = rfm_get_pixbuf(*g, sizes[i]);
        if (!pixbuf) 
            DBG("create_find_dialog(): cannot create pixbuf at size %d\n", sizes[i]);
        gtk_icon_theme_add_builtin_icon(*(g+1),sizes[i],pixbuf);
    }


}
#endif

static regex_t supported;
static gboolean regex_compiled = FALSE;

G_MODULE_EXPORT gboolean
svg_supported (void) {
    static int support = 2;
    if(support < 2)
        return (gboolean) support;
    else
        support = 0;
    GSList *l;
    GSList *pix_formats = NULL;
    if(!pix_formats)
        pix_formats = gdk_pixbuf_get_formats ();
    for(l = pix_formats; l; l = l->next) {
        gchar **pix_mimetypes;
        int i;
        GdkPixbufFormat *fmt = l->data;
        pix_mimetypes = gdk_pixbuf_format_get_mime_types (fmt);
        for(i = 0; pix_mimetypes[i]; i++) {
            if(g_ascii_strcasecmp (pix_mimetypes[i], "image/svg") == 0) {
                support = 1;
                break;
            }
        }
        g_strfreev (pix_mimetypes);
    }
    g_slist_free (pix_formats);
    return (gboolean) support;
}



static int
open_theme (void) {
    // If there is a version mismatch, then the cache will not
    // work with this version of Rodent and must be regenerated
    // before the main thread can continue.
    //
    if (gtk_icon_theme_get_default ()) {
	// Main thread should wait for cache to be generated.
	// If cache is up to date, then this function call should
	// return ipso facto.
	//
	// We pass NULL here so that function will not
	// enter endless loop to monitor gtk icon theme. 
	// Data parameter is also the nice wait period, in
	// seconds.
	if (!compare_cache_info ()){
	    DBG("** creating icontheme cache...\n");
	    create_new_gtk_cache(NULL);
	} else {
	    DBG("** loading icontheme cache...\n");
	    load_path_cache();
	} 
	// fire up gtk theme monitor.
	NOOP ("** background Starting GTK theme monitor\n");
	THREAD_CREATE( create_new_gtk_cache, GINT_TO_POINTER(5), "create_new_gtk_cache");
    }
    return 1;
}


static 
gint
create_icontheme_path_cache (void) {
    // This is to create a cache for full paths for icons.
    if(open_theme () < 0) {
        DBG ("create_icontheme_path_cache(): cannot load theme\n");
        return -1;
    }

    // This is to create a g_hash which will associate mimetype with an icon
    // the mimetype/icon association hash is created by parsing the xml file.
    gchar *mimefile = mime_icon_get_local_xml_file ();
    NOOP ("create_icontheme_path_cache(): looking for: %s\n", (mimefile ? mimefile : "null"));

    /* test for default mimefile  */
    if(!mimefile || !g_file_test (mimefile, G_FILE_TEST_EXISTS)) {
       NOOP ("%s: not found. \n", (mimefile ? mimefile : "null"));
       g_free (mimefile);
       mimefile = mime_icon_get_global_xml_file ();
       NOOP ("Now looking for: %s\n", (mimefile ? mimefile : "null"));
    }

    if(!mimefile || !g_file_test (mimefile, G_FILE_TEST_EXISTS)) {
        DBG ("No system wide mime file found: %s\n", (mimefile ? mimefile : "null"));
        g_free (mimefile);
        mimefile = NULL;
	return FALSE;
    }

    gboolean result = create_icon_hash (mimefile);
    g_free (mimefile);
    if(!result) {
	DBG ("cannot create basename_hash from mimefile:%s!\n", (mimefile ? mimefile : "null"));
    }
    return result;
}


